// dialmonDlg.h : header file
//

#ifdef	 WIN32
#include "trayicon.h"
#endif	 /* WIN32 */

/////////////////////////////////////////////////////////////////////////////
// CDialmonDlg dialog

class CDialmonDlg : public CDialog
{
public:
	CDialmonDlg (CWnd* pParent = NULL) ;
       ~CDialmonDlg () ;

	//{{AFX_DATA(CDialmonDlg)
	enum { IDD = IDD_DIALMON_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDialmonDlg)
protected :
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
		//}}AFX_VIRTUAL

public:

	void	SetState	(char *) ;
	void	SetMessage	(char *, BOOL = FALSE) ;        
	void	SetMode		(char *) ;
	void	SetIface	(char *) ;
	void	AllowDown	(int   ) ;
	void	AllowUp		(int   ) ;
	void	AllowCtrl	(int   ) ;
	void	AllowSet	(int   ) ;
	void	AddConfig	(char *) ;
	void	SetConfig	(char *) ;
	void	SetBWidth	(char *) ;
	void	SetLoad		(char *) ;
	void	Queue		(char *) ;
	void	Logging		(char *) ;
	void	OnHelp		()	 ;
	void	OnAbout		()	 ;
	void	doExit	   	()	 ;
	void	DrawMode	()	 ;
	void	ClrConfig	()	 ;
	void	Reset		()	 ;

#ifdef	WIN32
	int	isConnected ()	const
	{	return	connected ;
	}	;
	CTrayIcon trayIcon ;
#endif	/* WIN32 */

protected:
	HICON 	m_hIcon		;

	long	conntime	;	/* Connection time		*/
	int	connected	;	/* Set when connected		*/
#define	UNKNOWN		0		/* Connection state unknown	*/
#define	DISCONNECTED	1		/* Link disconnected		*/
#define	CONNECTED 	2		/* Link connected		*/

#ifdef	WIN32
	int	display_connect	;	/* Set to display connected	*/
	LRESULT	IconMenu ()	;
	int	qidx		;
	int	lidx		;
	int	showq		;
	int	showl		;
	int	minht		;
	int	maxht		;
	int	width		;
#endif	/* WIN32 */

	long	rgb_upfor	;

	// Generated message map functions
	//{{AFX_MSG(CDialmonDlg)
	virtual BOOL	OnInitDialog	() ;
	afx_msg	void	OnPaint		() ;
	afx_msg void	OnSysCommand	(UINT nID, LPARAM lParam) ;
	afx_msg HCURSOR OnQueryDragIcon	() ;
	afx_msg void	OnConfig	() ;
	afx_msg void	OnUp		() ;
	afx_msg void	OnDown		() ;
	afx_msg	void	OnForce		() ;
	afx_msg	void	OnNormal	() ;
	afx_msg	void	OnBlock		() ;
	afx_msg	void	OnRestart	() ;
	afx_msg void	OnMove		(int, int) ;
	afx_msg	void	OnTimer		(UINT) ;
	afx_msg	void	OnRestore	() ;
	afx_msg	HBRUSH	OnCtlColor	(CDC *, CWnd *, UINT) ;
	virtual void	OnCancel	() ;
#ifdef	WIN32
	afx_msg	void	OnQueue		() ;
	afx_msg	void	OnLog		() ;
	afx_msg	void	OnLogReload	() ;
	afx_msg void	OnConnect	() ;
	afx_msg	LRESULT OnTrayNotify	(WPARAM, LPARAM) ;
#endif	/* WIN32 */
	afx_msg void	OnSize		(UINT nType, int cx, int cy) ;

		void	DrawBar		(CWnd &, int *) ;
		void	DrawBar		(CWnd &, int  ) ;
	//}}AFX_MSG

	CString 	strAboutMenu	;
	CString 	strLinkUp	;
	CString 	strLinkDown	;
	CString 	strConfig 	;
	CString 	strConnect	;
	CString		strHelp		;

	CWnd		wUpFor		;	/* Up-for display	*/
	CWnd		wTxBar		;	/* Transmit load bar	*/
	CWnd		wRxBar		;	/* Receive load bar	*/
	RECT		txrxRect	;	/* Sizes of above	*/
	CPen		*penBack	;	/* Load background	*/
	CPen		*penFore	;	/* Load foreground	*/
	CBrush		*brushBack	;	/* Load background	*/
	CBrush		*brushFore	;	/* Load foreground	*/
	long		bwidth		;	/* Nominal bandwidth	*/
	int		modeico		;	/* Mode icon identifier	*/

	int		*txvals		;	/* Transmit values	*/
	int		*rxvals		;	/* Receive values	*/
	long		txtotal		;	/* Tranmit sum		*/
	long		rxtotal		;	/* Receive sum		*/
	int		loadidx		;	/* Load display index	*/
	DECLARE_MESSAGE_MAP()
};

#define	DEFBWIDTH	(33600L / 10L)
